<script setup lang="ts">
import { io, Socket } from 'socket.io-client';
import { onMounted, ref } from 'vue';
import type { Message } from './entities'

const newMessages = ref(0);
const typingUsers = ref<string[]>([]);
const isTyping = ref<number | null>(null);
const message = ref('');
const messageList = ref<Message[]>([]);
const username = ref('');
const error = ref('');
const usernameList = ref<string[]>([]);
let socket:Socket;
/**
 * Tout ça sera lancé à l'initialision du composant
 */
onMounted(() => {
  socket = io('ws://10.0.10.174:8000');
  socket.on('greeting', (data) => console.log(data));
  socket.on('user-list', data => usernameList.value = data);
  socket.on('message-list', data => messageList.value = data);
  socket.on('new-message', data => {
    messageList.value.unshift(data)
    //Tout ça c'est pour envoyer une notification lors d'un nouveau message si la fenêtre n'a pas le focus
    if(document.hidden && usernameList.value.includes(username.value)) {
      new Notification(data.username +':'+data.content);
      newMessages.value++;
      document.title = 'Chat - '+newMessages.value+' new messages';
      
    }
  });
  socket.on('typing', data => typingUsers.value.push(data));
  socket.on('typing-stop', data => typingUsers.value.splice(typingUsers.value.indexOf(data), 1));

  Notification.requestPermission();
  window.onfocus = () => {
    newMessages.value =0
    document.title = 'Chat';
  }
});


function chooseUsername() {
  socket.emit('choose-username', username.value, (data: any) => {
    console.log(data);
    if (data.status == 'error') {
      error.value = data.msg;
    }
  });
}
function sendMessage() {
  socket.emit('message-post', message.value);
  message.value = '';
}
function sendTyping() {
  if (message.value.length > 0) {
    if (isTyping.value) {
      clearTimeout(isTyping.value);
      isTyping.value = null;
    } else {
      socket.emit('typing');
    }
    isTyping.value = setTimeout(() => {
      socket.emit('typing-stop');
      isTyping.value = null
    }, 2000);

  }

}
</script>

<template>
  <main>
    <form class="chat" @submit.prevent="chooseUsername()" v-if="!usernameList.includes(username)">
      <p v-if="error">{{error}}</p>
      <label for="username">Username :</label>
      <input type="text" name="username" id="username" v-model="username">
      <button>Choose</button>
    </form>

    <div class="chat" v-if="usernameList.includes(username)">
      <section>
        <p v-if="typingUsers.length">{{typingUsers.join(', ')}} are typing...</p>

        <div v-for="item of messageList">
          [{{new Date(item.postDate).toLocaleString()}}] {{item.username}} : {{item.content}}
        </div>
      </section>
      <form class="send" @submit.prevent="sendMessage()">
        <label for="message">Message :</label>
        <input type="text" name="message" id="message" v-model="message" @input="sendTyping()" />
        <button>Send</button>
      </form>
    </div>
    <ul>
      <li v-for="user of usernameList">{{user}}</li>
    </ul>
  </main>

</template>

<style scoped>
main {
  display: flex;
}

ul {
  width: 20%;
  padding: 3%;
  border: 1px solid black;
  overflow-x: hidden;
  overflow-y: scroll;
  height: 100vh;
  margin: 0;
}

.chat {
  width: 80%;
  height: 100vh;
  padding: 3%;
  border: 1px solid black;

}

.chat section {
  height: 80vh;
  border-bottom: 1px solid black;
  overflow-y: scroll;
  display: flex;
  flex-direction: column-reverse;
}

.chat .send {
  height: 10vh;
  display: flex;
  align-items: center;
}
</style>
